
//+------------------------------------------------------------------+
//|                                                PB_BasicFuncs.mq4 |
//|                                                      PunkBASSter |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "PunkBASSter"
#property link      "http://www.mql4.com/ru/users/PunkBASSter"

/*
 -         .
   :

1.   :
int OpenInstant(int cmd, int stoploss, int takeprofit, int magic)
    price   

int OpenPending(int cmd, double price, int stoploss, int takeprofit, int magic, datetime exp)
  .

2.  ,  :
bool CloseOrder(int ticket)
  /     

3.       c  :
int RefreshTicket(int magic)

4.   
int ErrorBlock()

      _TryCount,   
   .   ,  ,
  - 

5.     
bool NoLoss(int ticket,int offset);

6.   
bool TrailingStop(int ticket,int trailingsize, int offset) //offset -         
bool CandleTrailingStop(int ticket, int timeframe, int minsize)// -    ,   
bool FractalTrailingStop(int ticket,int timeframe) timeframe    
bool SARTrailingStop(int ticket, int timeframe, double step, double max) 

*/

//  
//+------------------------------------------------------------------+
int _Slippage=30;//
bool _TradeFlag=true;//      
int _TryCount=7; //  // 
string _Symbol; //  
int _SleepTime=7000;//    
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|         |
//+------------------------------------------------------------------+
int RefreshTicket(int magic)
{
   int ticket=-1;
   for(int p=OrdersTotal(); p>=0; p--)
   {
      if(OrderSelect(p,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderSymbol()==_Symbol && OrderMagicNumber()==magic && OrderCloseTime()==0)
         {
            ticket=OrderTicket();
         }
         else continue;
      }
      else continue;
   }
   return (ticket);
}
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|   OrderModify(...),                  |
//+------------------------------------------------------------------+
bool ModifyOrder(int ticket, double open, double SL, double TP, datetime exp)
{
   for(int i=1; i<=_TryCount; i++)
      {
         Print("  ",i, "  #",ticket);
         if(OrderModify(ticket, open, SL, TP,exp, CLR_NONE))
            {Print(" ");return (true);}
         if(ErrorBlock()>1)
            {Print("  - ");return (false);}
         Sleep(_SleepTime);
      }
}
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
int OpenInstant(int cmd, double lot, int stoploss, int takeprofit, int magic)
{  
   if(!_TradeFlag)return (-1);//,   
   
   int ticket=0;
   double SL,TP;
   double price=0;
   color arrow=Green;
   
   SL=NormalizeDouble(stoploss*Point,Digits);
   TP=NormalizeDouble(takeprofit*Point,Digits);
   
   if(cmd == OP_SELL) {SL=-SL; TP=-TP; arrow=Red;}
   
   for(int i=1; i<=_TryCount; i++)
      {
      RefreshRates();
         if(cmd == OP_BUY )
          price = NormalizeDouble(Ask, Digits);
         if(cmd == OP_SELL)
          price = NormalizeDouble(Bid, Digits);
      
      Print("   #",i);
      
      if(TP!=0)//  
      ticket=OrderSend(_Symbol, cmd, lot, price, _Slippage, price-SL, price+TP, NULL, magic, 0, arrow);
      else // 
      ticket=OrderSend(_Symbol, cmd, lot, price, _Slippage, price-SL, 0, NULL, magic, 0, arrow);
      
      if(ticket>0)
         {
         Print(" .");
         return(ticket);
         }
              
      if(ErrorBlock()>1)return(-1);//  1  ,     .
      Sleep(_SleepTime);
      }
Print("  .   ");
return(-1);   
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
int OpenPending(int cmd, double price, double lot, int stoploss, int takeprofit, int magic, datetime exp)
{  
   if(!_TradeFlag)return (-1);//,   
   
   int ticket=0;
   double SL,TP;
   price=NormalizeDouble(price,Digits);//  
   color arrow=Green;
      
   SL=NormalizeDouble(stoploss*Point,Digits);
   TP=NormalizeDouble(takeprofit*Point,Digits);
   
   if(cmd==OP_SELLSTOP || cmd ==OP_SELLLIMIT){SL=-SL;TP=-TP;arrow=Red;}
   
   for(int i=1; i<=_TryCount; i++)
      {
      Print("   #",i);
      
      if(TP!=0)//  
      ticket=OrderSend(_Symbol, cmd, lot, price, _Slippage, price-SL, price+TP, NULL, magic, exp, arrow);
      else // 
      ticket=OrderSend(_Symbol, cmd, lot, price, _Slippage, price-SL, 0, NULL, magic, exp, arrow);
      
      if(ticket>0)
         {
         Print(" .");
         return(ticket);
         }
              
      if(ErrorBlock()>1)return(-1);//  1  ,     .
      Sleep(_SleepTime);
      }
Print("  .   ");
return(-1);   
}
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
bool CloseOrder(int ticket)
{     
   if(OrderSelect(ticket, SELECT_BY_TICKET)==false)return (false);
   
   double price;
   
      for(int i=1; i<=_TryCount; i++)
      {
         Print(" /  #",i);
           
         RefreshRates();
      //----  
         if(OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP
            || OrderType()==OP_SELLLIMIT || OrderType()==OP_SELLSTOP)
               if(OrderDelete(ticket,CLR_NONE))                         //
               {
                  Print("   ", ticket, " .");
                  return (true);
               }
               
      //----  
         if(OrderType()==OP_BUY)
            price=Bid;//  
         if(OrderType()==OP_SELL)
            price=Ask;//    
            if(OrderClose(ticket, OrderLots(), price, _Slippage, Red))  //
            {
               Print("   ", ticket, " .");
               return (true);
            }
      //----   ,     
         if(ErrorBlock() > 1) //  
         {
            Print("    ", OrderTicket());
            return(false);    //
         }
      
      //----   ,    
      Sleep(_SleepTime);   
      }
   return (false); //        ,  
}
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| // 0- , 1-   , 2- ,   |
//|    3-                                             |
//+------------------------------------------------------------------+
//   
int ErrorBlock()
  {
   int err = GetLastError();
   switch(err)
     {
       case 0: return(0);
       case 2:
         {
           Print(" .  / ");
           _TradeFlag = false;
           return(3);  
         }
       case 3:
         {
           Print("   ");
           _TradeFlag = false;
           return(3);   
         }
       case 4:
         {
           Print("  .  1 ");
           Sleep(60000);
           return(1);   
         }
       case 6:
         { 
           bool connect = false;
           int iteration = 0;
           Print("Disconnect ");
           while(!connect)
             {
               Sleep(10000);
               Print("  ,  ", iteration*10,
                     "  ");
               connect = IsConnected();
               if(connect)
                 {
                   Print(" ");
                   return(1);
                 }
               iteration++;
             }
           //_TradeFlag = false; 
           Print("  ");
           return(2);
         }
       case 8:
         {
           Print(" ");
           _TradeFlag = false; 
           return(3);
         }
       case 64:
         {
           Print(" !");
           _TradeFlag = false; 
           return(3);            
         }
       case 65:
         {
           Print("  ???");
           _TradeFlag = false; 
           return(3);            
         }
       case 128:
         {
           Print("   ");
           return(2);
         }
       case 129:
         {
           Print(" ");
           return(1);            
         }
       case 130:
         {
           Print(" ");
           return(3);
         }
       case 131:
         {
           Print("   ");
           _TradeFlag = false;            
           return(3);
         }
       case 132:
         {
           Print(" ");
           _TradeFlag = false; 
           return(2);
         }
       case 134:
         {
           Print("     ");
           _TradeFlag = false;             
           return(2);
         }
       case 135:
         {
           Print(" ");
           return (1);
         }
       case 136:
         {
           Print(" !");
           return(2);
         }
       case 138:
         {
           Print("!");
           return(1);
         }
       case 139:
         {
           Print("  .  ");
           return(2);
         }
       case 141:
         {
           Print("  ");
           _TradeFlag = false; 
           return(2);            
         }
       case 148:
         {
           Print("   ");
           _TradeFlag = false; 
           return(2);            
         }
                                                 
     }
   return (0);
  }
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
bool NoLoss(int ticket,int offset)//       
{
   if(offset==0)return(false);//  
  
   if(!OrderSelect(ticket,SELECT_BY_TICKET))return(false);
   if(OrderCloseTime()>0)return(false);
   
   if(OrderType()==OP_BUY)
   {
    if(OrderStopLoss()>=OrderOpenPrice())return(true);
     if(Ask>=OrderOpenPrice()+offset*Point)
      if(ModifyOrder(ticket,OrderOpenPrice(),OrderOpenPrice(),
         OrderTakeProfit(),0))return(true);
   }   
   if(OrderType()==OP_SELL)
   {
    if(OrderStopLoss()<=OrderOpenPrice())return(true);
     if(Bid<=OrderOpenPrice()-offset*Point)
      if(ModifyOrder(ticket,OrderOpenPrice(),OrderOpenPrice(),
         OrderTakeProfit(),0))return(true);
   }
return (false);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|  . trailingsize -     |
//+------------------------------------------------------------------+
bool TrailingStop(int ticket, int trailingsize, int offset)
{  
   if(trailingsize==0)return(false);//  
   double spread=MarketInfo(_Symbol,MODE_SPREAD);
      if(OrderSelect(ticket,SELECT_BY_TICKET)
      && OrderCloseTime()==0 && OrderProfit()>0)
         {
            double trail=trailingsize*Point;
            //~~~~~~~~~~Trailing Buys~~~~~~~~~~~~~
            if(OrderType()==OP_BUY)
               if(OrderStopLoss()<Bid-offset*Point-trail)
                  if(ModifyOrder(ticket,OrderOpenPrice(),Bid-trail,
                     OrderTakeProfit(),0))
                        return(true);
            //~~~~~~~~~~Trailing Sells~~~~~~~~~~~~                        
            if(OrderType()==OP_SELL)
               if(OrderStopLoss()>Ask+offset*Point+trail)
                  if(ModifyOrder(ticket,OrderOpenPrice(),Ask+trail,
                     OrderTakeProfit(),0))
                        return(true);
         }
   return (false);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|   .                                       |
//+------------------------------------------------------------------+ 
/*
bool CandleTrailingStop(int ticket, int tf, int minsize)
{  
   if(tf==0 || minsize==0)return(false);//  
   double spread=MarketInfo(_Symbol,MODE_SPREAD);
      if(OrderSelect(ticket,SELECT_BY_TICKET)
      && OrderCloseTime()==0 && OrderProfit()>0)
         {
            double stop=iOpen(_Symbol, tf, 1);
            double size=MathAbs(iClose(_Symbol,tf,1)-iOpen(_Symbol,tf,1));
            //~~~~~~~~~~Trailing Buys~~~~~~~~~~~~~
            if(OrderType()==OP_BUY)
               if(OrderStopLoss()<Bid-minsize*Point //       - 
               && OrderStopLoss()<stop //     
               && size>minsize*Point //     
               )
                  if(ModifyOrder(ticket,OrderOpenPrice(),stop,
                     OrderTakeProfit(),0))//
                        return(true);
            //~~~~~~~~~~Trailing Sells~~~~~~~~~~~~                        
            if(OrderType()==OP_SELL)
               if(OrderStopLoss()>Ask+minsize*Point //       - 
               && OrderStopLoss()>stop //     
               && size>minsize*Point //     
               )
                  if(ModifyOrder(ticket,OrderOpenPrice(),stop,
                     OrderTakeProfit(),0))//
                        return(true);
         }
   return (false);
}*/
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|   .                                   |
//+------------------------------------------------------------------+
bool FractalTrailingStop(int ticket, int timeframe)//
{
   if(timeframe==0)return(false);//  
      if(OrderSelect(ticket,SELECT_BY_TICKET)
      && OrderCloseTime()==0 && OrderProfit()>0)
         {
         double FractalUp=0;//  -
         for(int k=0; k<=500; k++){FractalUp=iFractals(_Symbol,timeframe,MODE_UPPER,k);if(FractalUp>0)break;}
         double FractalDn=0;//  -
         for(int n=0; n<=500; n++){FractalDn=iFractals(_Symbol,timeframe,MODE_LOWER,n);if(FractalUp>0)break;}        
            //~~~~~~~~~~Trailing Buys~~~~~~~~~~~~~
            if(OrderType()==OP_BUY)
               if(OrderStopLoss()<FractalDn && FractalDn>0 && FractalDn<Close[0])// 
                  if(ModifyOrder(ticket,OrderOpenPrice(),FractalDn,
                     OrderTakeProfit(),0))
                        return(true);
            //~~~~~~~~~~Trailing Sells~~~~~~~~~~~~                        
            if(OrderType()==OP_SELL)
               if(OrderStopLoss()>FractalUp && FractalUp>0 && FractalDn>Close[0])// 
                  if(ModifyOrder(ticket,OrderOpenPrice(),FractalUp,
                     OrderTakeProfit(),0))
                        return(true);
         }
   return (false);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|    .                                 |
//+------------------------------------------------------------------+
bool SARTrailingStop(int ticket, int timeframe, double step, double max)//
{
   if(timeframe==0)return(false);//  
      if(OrderSelect(ticket,SELECT_BY_TICKET)
      && OrderCloseTime()==0 && OrderProfit()>0)
         {
         double SAR=iSAR(_Symbol,timeframe, step, max, 0);      
            //~~~~~~~~~~Trailing Buys~~~~~~~~~~~~~
            if(OrderType()==OP_BUY)
               if(OrderStopLoss()<SAR && SAR<Close[0])// 
                  if(ModifyOrder(ticket,OrderOpenPrice(),SAR,
                     OrderTakeProfit(),0))
                        return(true);
            //~~~~~~~~~~Trailing Sells~~~~~~~~~~~~                        
            if(OrderType()==OP_SELL)
               if(OrderStopLoss()>SAR && SAR>Close[0])// 
                  if(ModifyOrder(ticket,OrderOpenPrice(),SAR,
                     OrderTakeProfit(),0))
                        return(true);
         }
   return (false);
}
//+------------------------------------------------------------------+